% Performs basic Riccati and feedback matrix iterations for finite time
% problems

function [Hr,Fr]=BasicRiccati(A,C,K,KT,R,T)

Hr(:,:,T)=KT;
Fr(:,:,T)=inv(C'*Hr(:,:,T)*C+R)*(C'*Hr(:,:,T)*A);

for t=T:-1:2
    Hr(:,:,t-1)=K+A'*Hr(:,:,t)*A-(A'*Hr(:,:,t)*C)*inv(C'*Hr(:,:,t)*C+R)*(C'*Hr(:,:,t)*A);
    Fr(:,:,t-1)=inv(C'*Hr(:,:,t-1)*C+R)*(C'*Hr(:,:,t-1)*A);
end

Hr
Fr
 