%If sub matrix C2 is not invertible, this function uses the
%full C matrix %as input and transforms it so that its matrix partition
%C2 has full rank equal to the rank of C.  It provides as output the permutation
%matrix P needed for the transformation.  The user provides the C
%matrix and the output is the permuation matrix P.  Typically,
%CNew =P*C.  Note that only the first function argument is required.

function [P, C2New, i, Q] = C2NotInvertible(C)

n=max(size(C));
rC=rank(C);
C2=C(n-rC+1:n,:);

v=[n:-1:1];
Q=perms(v);

qq=factorial(n);
qqq=factorial(n);

for k=qqq-1:-1:1
    for j=qq:-1:k+1
        if Q(k, n-rC+1:n)==Q(j, n-rC+1:n)
           Q(j,:)=[];
           qq=qq-1;
       end
   end
end

i=1;
CNew=C;
C2New=C2;

while rank(C2New)<rank(C)& i<factorial(n)/factorial(n-rC)
    i=i+1;
	CNew=C(Q(i,:),:);
	C2New=CNew(n-rC+1:n,:);
   
end;

I=eye(n);
P=I(Q(i,:),:);

if rank(C2New)<rC
    disp('More complex transformation needed: BSubNew still not invertible');
end;
