% Exercise 4.3 in Ljungqvist and Sargent (2000, p.76).
% Note that the problem is controllable and observable in the Chow form and
% therefore its state vector is minimal at a size of.
% Nevertheless, the dynamic kernel is smaller, equal to 1.

% Warning.  There are some problems with this example unrelated to our
% reduction approach.  In particular, applying the OLRP program of 
% Ljungqvist and Sargent gives different results depending on whether you
% start from Chow form or the regular formulation.  Also OLRP often crashes 
% on this example, and DARE won't run. There also appear to be
% some mistakes in the pdf document by Ljungqvist, Lustig, Manuelli, Sargent, 
% Nieuwerburgh, and Weill which has the (preliminary) answers to the
% exercises in Ljungqvist and Sargent (2000): J is incorrectly multiplied
% by 2 and there should be a b^2 as the (4,4) element of the Kbar matrix
% (which they call R). The answers in the pdf document can be replicated if
% we use the wrong 2*J matrix.

b=0.95;
c=1;

r=(1/b)-1
bb=30
gamma=1
rho1=1.2
rho2=-0.3
lambda=1
pi=0.05
delta=0.95
theta=1

Abar=[1 0 0 0; 0 rho1 rho2 0; 0 1 0 0; 0 0 0 1]
Cbar=[1; 0; 0; 0]
Kbar=[(r^2) r 0 -bb*(r); (r) 1 0 -bb; 0 0 0 0; -bb*(r) -bb 0 bb^2]
G=[0 0; 0 1; 0 0; 0 0];

% according to preliminary answers by Ljungqvist, Lustig, Manuelli, Sargent, Nieuwerburgh, and Weill
% J is incorrectly multiplied by 2.  This does reproduce their results :
J=2*[-r -1 0 bb]'

R=1+gamma
u0bar=zeros(1);
[nbar,kbar]=size(Cbar)

y0bar=[1; 1; 1; 1]
T=6

D=[r 1 0 -bb -1; 0 0 0 0 gamma^(0.5)];

disp('Answer based on OLRP:')

% [f,p]=olrp(b,Abar,Cbar,Kbar,R,J)


