% Transformation to render the LQC problem controllable

function [Ac, Cc, Kc, S]=RedCon(A,C,K)

[n,k]=size(C);
for i=1:n
    Contr(1:n,(i-1)*k+1:(i)*(k))=(A^(i-1))*C;
end
Contr;
rcon=rank(Contr);

cc=zeros(n,rcon);

for i=1:rcon
    j=1;
    while rank(cc(1:n,1:i))<i
        cc(1:n,i)=Contr(1:n,j);
        Contr(:,j)=[];
    end
end
cc;

S=cc;
V=pinv(S);
Ac=V*A*S;
Cc=V*C;
Kc=S'*K*S;

% S is the transformation matrix
% F*S=Fc
% S'*H*S=Hc

% ending of file RedCon.m
% Copyright July 2003, Ronald J. Balvers, West Virginia University.