% Transform the LQC problem to render all states observable

function [Ao, Co, Ko, Vo]=RedObs(A,C,D)

[d,n]=size(D);
for i=1:n
    Obs(1:n,(i-1)*d+1:(i)*(d))=(A'^(i-1))*D';
end
Obs;
robs=rank(Obs);

dd=zeros(n,robs);

for i=1:robs
    j=1;
    while rank(dd(1:n,1:i))<i
        dd(1:n,i)=Obs(1:n,j);
        Obs(:,j)=[];
    end
end
dd;

So=dd;
Vo=pinv(So);
Ao=So'*A*Vo';
Co=So'*C;
Do=D*Vo';
Ko=Do'*Do;

% Vo' is the transformation matrix
% F*Vo'=Fo
% Vo*H*Vo'=Ho

% ending of file RedObs.m
% Copyright July 2003, Ronald J. Balvers, West Virginia University.