%If Matrix B and sub matrix BSub are not invertible, this function uses the
%full B matrix %as input and transforms it so that its matrix partition
%has full rank equal to the rank of B.  It provides as output the permutation
%matrix P needed for the transformation.  The user provides the B
%matrix and the output is the permuation matrix P.  Typically,
%BNew =P*B*P'.  Note that only the first function argument is required.

function [P, BSubNew, i, Q] = SubNotInvertible(B)

q=max(size(B));
rB=rank(B);
BSub=B(1:rB, 1:rB);

v=[q:-1:1];
Q=perms(v);

qq=factorial(q);
qqq=factorial(q);
for k=qqq-1:-1:1
    for j=qq:-1:k+1
        if Q(k, 1:rB)==Q(j, 1:rB)
           Q(j,:)=[];
           qq=qq-1;
       end
   end
end

i=1;
BNew=B;
BSubNew=BSub;

while rank(BSubNew)<rank(BNew)& i<factorial(q)/factorial(q-rB)
    i=i+1;
	BNew=B(Q(i,:), Q(i,:));
	BSubNew=BNew(1:rB, 1:rB);
   
end;

I=eye(q);
P=I(Q(i,:),:);

if rank(BSubNew)<rB
    disp('More complex transformation needed: BSubNew still not invertible');
end;
